REM Last Changed: 10/22/2002
ECHO OFF
CLS

ECHO Building The Matrix Screen Saver by Greg Dietsche

REM Pre-Compile the Tsr Event Hook. This will output a file called hook.bin
REM you may want to experiment with -fomit-frame-pointer, -mpcrel, and -mregparm 
REM to see if they decrease the size of your project. If you try this, be sure 
REM to test your project and make sure that these options do not have negative
REM side effects
CALL tigcc -O3 -W -Wall -fomit-frame-pointer -mpcrel -outputbin hook.c Handler.c Data.c MatrixCode.c extgraph.a

REM convert the raw binary image to an array
ttbin2hex -a tsr -ss 2 -se 1 hook.bin array.h

REM compile the install program with the tsr hook included as an array.
tigcc -Os -W -Wall -mpcrel matrix.c h220xtsr.a

REM do some cleanup
DEL hook.bin

ECHO Build Completed!
ECHO ON
pause