// C Source File
// Created 10/22/2002; 12:01:36 PM
#define OPTIMIZE_ROM_CALLS				// Use Speed Optimization
#define NO_EXIT_SUPPORT					 //no need for exit or atexit

#define MIN_AMS 200
//#define NO_AMS_CHECK

#define NO_CALC_DETECT

#define	USE_TI89
#define	USE_TI92PLUS
#define USE_V200

#define fatal(s) {ST_showHelp(s);return;}

#include <tigcclib.h>			//Include All Header Files
#include "AppDef.h"
#include "h220xTSR.h"		 //Kevin Kofler's hw2 ams2 tsr support
#include "array.h"			//The pre-compiled EVENT HOOK

//This Code needs TIGCC 0.94 beta 19 at the very least to function properly
#if __TIGCC__==0 && __TIGCC_MINOR__< 94 && __TIGCC_BETA__ < 19
	#warning Sample TSR - Old TIGCC Version -- Check tigcc.ticalc.org for updates
#endif

// Main Function
void _main(void)
{
	volatile HANDLE tsrHandle; //Handle of allocated mem for the Hook
	char		*pTsr;	 					//a pointer to the actual mem for the Hook
	void *pHook=EV_hook-16;	 //points to where evHk should be in an installed hook
	
	void (*HookMain)(char*,unsigned short); //a pointer to the event hook's Install_TSR function
	char *pass=NULL;
	unsigned int apd=0,timeout=0;
	ESI argptr;
	char buff[200];
		
/////////////////////////////////////////
// Program independent error checking	//
///////////////////////////////////////

	//see if the hook has already been installed
		if(EV_hook)
			while(pHook)
			{
			//This code essentially says if(memcmp(tsr,pHook,4))
			//where char tsrsig[4]={'e','v','H','k'}; 1785
			//0x6576486B==#'evHk'
				if(0x6576486B!=*(unsigned long*)pHook)
					break;//the installed hook does not follow the convention, so no more checking can be done
					
			//Already installed
				if(!memcmp(pHook,tsr,12))
					fatal("Already Installed!");
			
			//Get the address for the next hook...
				(unsigned long)pHook=*(unsigned long*)(pHook+12)-16;
			}
			
	//Read any arguments....
	InitArgPtr(argptr);
	
	if(RemainingArgCnt(argptr))
		if(GetArgType(argptr)==STR_TAG)
			pass=(char*)GetStrnArg(argptr);
			
		if(RemainingArgCnt(argptr))
			if(GetArgType(argptr)==POSINT_TAG)
				timeout=GetIntArg(argptr)*20;
				
		if(RemainingArgCnt(argptr))
			if(GetArgType(argptr)==POSINT_TAG)
				apd=GetIntArg(argptr)*20;

	if(!apd)
	{
		OSTimerRestart(APD_TIMER);
		apd=OSTimerCurVal(APD_TIMER);
	}
	
	if(!timeout)
		timeout=apd/2;
	else
		timeout=apd-timeout;
		
		if(apd<200)		//10 second min
		apd=200;
		
	if(apd-timeout<100)	//5 second min 
		timeout=100;
		
	if(strlen(pass)>8)
		pass[8]=0;
		
	sprintf(buff,"Current Settings:\n"
							 "Screen Saver: %u seconds\nAPD: %u seconds\nPassword: '%s'"
							 "\n\nContinue Installation?",
					(apd/20)-(timeout/20),apd/20,pass);
					
	if(DlgMessage(""APP_TITLE " v" APP_VERSION,buff,BT_YES,BT_NO)==KEY_ESC)
		fatal("Installation Canceled!");

//set the apd timer...
	OSFreeTimer(APD_TIMER);
	OSRegisterTimer(APD_TIMER,apd);
	
///////////////////////////////////
// End Error checking/handling	//
/////////////////////////////////

	//sort of like a call to a permanent version of enter_ghost_space();
		if(!h220xTSR())
			fatal("Low RAM!");
			
	//allocate RAM for the Event Hook
		if(!(tsrHandle=HeapAllocHigh(sizeof(tsr))))
			fatal("Low RAM!");

	//get a pointer to the actual mem and make it point in the "ghost space"
	//ghost space is essentially a shadow of regular ram which is not protected very
	//well by the hardware... subtract 0x40000 to get the real address
		pTsr=HeapDeref(tsrHandle)+0x40000;

	//Copy The tsr array to its new location
		memcpy(pTsr,tsr,sizeof(tsr));
		
	//Save the Old tsr hook's address for the uninstall prog and for this hook to call
		*(unsigned long*)&pTsr[12]=(unsigned long)EV_hook;
		
		EX_patch(pTsr,pTsr+sizeof(tsr));

		(unsigned char*)HookMain=&pTsr[16];

		HookMain(pass, timeout);	//pass the buffer, and timeout values to the install function
		EV_hook=(EVENT_HANDLER)HookMain;	//Hook Main Patches itsself so that its starting address jumps to the EventHandler

	//TODO: You should change or remove this line as necessary
		fatal("The Matrix v" APP_VERSION " Installed!");
}
